import type { ReactNode } from "react";
import type { EmotionCache } from "@emotion/cache";
import type { Options as OptionsOfCreateCache } from "@emotion/cache";
import type { NextComponentType } from "next";
/**
 * @see <https://docs.tss-react.dev/ssr/next>
 * This utility implements https://emotion.sh/docs/ssr#advanced-approach
 * */
export declare function createEmotionSsrAdvancedApproach(
/** This is the options passed to createCache() from 'import createCache from "@emotion/cache"' */
options: Omit<OptionsOfCreateCache, "insertionPoint"> & {
    prepend?: boolean;
}, 
/** By default <CacheProvider /> from 'import { CacheProvider } from "@emotion/react"' */
CacheProvider?: (props: {
    value: EmotionCache;
    children: ReactNode;
}) => JSX.Element | null): {
    withAppEmotionCache: <AppComponent extends NextComponentType<any, any, any>>(App: AppComponent) => AppComponent;
    augmentDocumentWithEmotionCache: (Document: NextComponentType<any, any, any>) => void;
};
